/*******************************************************************************************************/
/*                                                                                                     */
/* Trigger: DTULTATU_MOTIVOTRAM                                                                        */
/* Tabela : MOTITRAMITACAO                                                                             */
/*                                                                                                     */
/* Criao:                                                                                            */
/* 05/11/2008 - GLEYDSON ISRAEL DA SILVA GAZOLA                                                        */
/*                                                                                                     */
/*******************************************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_MOTIVOTRAM
BEFORE INSERT OR UPDATE OR DELETE
ON MOTITRAMITACAO FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUMOTITRA := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDMOTITRAMITA,0) <> NVL(:NEW.CDMOTITRAMITA,0)) OR
         (NVL(:OLD.NMMOTITRAMITA,0) <> NVL(:NEW.NMMOTITRAMITA,0)) THEN
         :NEW.DTULTATUMOTITRA := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('MOTITRAMITACAO', '', 'CDMOTITRAMITA='||:OLD.CDMOTITRAMITA||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE MOTITRAMITACAO MODIFY DTULTATUMOTITRA DEFAULT SYSDATE
/

-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_MOTIVOTRAM','5.05.018'); END;
/
